Sync our gcc5 manual pages with gcc-5.4.0
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 5.0 TO LATER VERSIONS                +
13 +-----------------------------------------------------------------------+
14
15 VARIOUS FORMER OPTIONS REMOVED
16 ------------------------------
17
18 Various former kernel configuration options which had been no-ops for
19 some time were completely removed: SYSVMSG, SYSVSEM, SYSVSHM, P1003_1B,
20 _KPOSIX_VERSION and DSCHED_FQ. Users that have any of these still in
21 their kernel configuration files have to remove them.
22
23 BOOTSTRAPPING LIMITED FROM PRE 4.4
24 ----------------------------------
25
26 Upgrading to 5.1 and later versions now require at least 4.4 in
27 preparations for upcoming base compilers updates.
28
29 IF_PPP, PPPD, IF_FAITH, AND FAITHD REMOVED
30 ------------------------------------------
31
32 if_ppp has been replaced by "user ppp", i.e. ppp(8) and tun(4). It had
33 already been removed from our default kernel configuration before 5.0,
34 so only people with custom configurations based on earlier X86_64_GENERIC
35 will have to remove it manually.
36
37 The faith(4) interface has been completely removed after it had also
38 been removed from our default kernel configuration. 
39
40 +-----------------------------------------------------------------------+
41 +         UPGRADING DRAGONFLY FROM 4.8 TO LATER VERSIONS                +
42 +-----------------------------------------------------------------------+
43
44 FFS_ROOT OPTION DISABLED
45 ------------------------
46
47 The FFS_ROOT option has been made a no-op and will be completely removed
48 at some point in the future. Users with a custom kernel configuration
49 can remove this option from it now.
50
51 +-----------------------------------------------------------------------+
52 +         UPGRADING DRAGONFLY FROM 4.6 TO LATER VERSIONS                +
53 +-----------------------------------------------------------------------+
54
55 AHC, AHD, AIC, NCV, NSP AND STG DRIVERS REMOVED
56 -----------------------------------------------
57
58 They were all in our X86_64_GENERIC kernel configuration file, along with
59 the AHC_REG_PRETTY_PRINT and AHD_REG_PRETTY_PRINT options, so any custom
60 configuration files derived from it need adjustment.
61
62 PORTAL FILE SYSTEM REMOVED
63 --------------------------
64
65 It has been broken for a long time now.
66
67 BINUTILS 2.27 REPLACES 2.24, PRIMARY
68 ------------------------------------
69
70 The oldest of the two versions of Binutils, version 2.24, was removed
71 and replaced with Binutils 2.27.  It becomes the primary version version
72 of binutils and version 2.25 becomes the alternate.
73
74 The accepted values of BINUTILSVER are now "binutils227" (default) and
75 "binutils225".  The building of Binutils 2.25 can be prevented by setting
76 NO_ALTBINUTILS=yes in make.conf.
77
78 COMPAT_43 KERNEL OPTION REMOVED
79 -------------------------------
80
81 It was commented out in our default configs for several years now, but
82 might still be present in custom configs created before Nov. 2011.
83
84 OPENSSL REMOVED
85 ---------------
86
87 OpenSSL has been removed from base and replaced with a private version of
88 LibreSSL.  The previously installed OpenSSL libraries, headers, and man
89 pages will remain on the system unless the "make upgrade" command is
90 specifically instructed to remove them.  To do this, define
91 REMOVE_OPENSSL_FILES for the upgrade command, e.g.
92 "make upgrade REMOVE_OPENSSL_FILES=yes"
93
94 28-Oct-2016: openssl has been replaced by ressl.  It is recommended that any
95 stale OpenSSL files be removed to avoid configuration scripts from using
96 the stale and potentially vulnerable version, but all binaries that are
97 dynamically linked to the OpenSSL libraries should be rebuilt first to
98 avoid breakage.
99
100 OPENSSH HPN REMOVED
101 -------------------
102
103 It has become too cumbersome to maintain HPN patches in OpenSSH in base.
104 To use OpenSSH in base remove HPN config, if you have added it.
105 Check files below for HPN config, see a few lines below.
106   /etc/ssh/ssh_config, /etc/ssh/sshd_config, ~/.ssh/config
107 sshd(8) will fail to start if HPN config is used.
108
109 NOTE: HPN config in sshd_config will prohibit remote access to host using ssh.
110
111 HPN config:
112 HPNDisabled
113 HPNBufferSize
114 TcpRcvBuf
115 TcpRcvBufPoll
116 NoneEnabled
117 NoneSwitch
118 cipher MTR-AES-CTR
119 cipher NONE
120
121 OpenSSH HPN is a patch set to OpenSSH providing higher performance under some
122 circumstances, especially for networking.
123 If HPN functionality is needed, install security/openssh from dports.
124
125 CS, EX AND VX DRIVERS REMOVED
126 -----------------------------
127
128 The cs(4), ex(4) and vx(4) drivers have been removed. They were very
129 old and its doubtful they ever worked properly in x86_64 but they were
130 in X86_64_GENERIC, so custom configurations derived from it have to be
131 adjusted.
132
133 +-----------------------------------------------------------------------+
134 +         UPGRADING DRAGONFLY FROM 4.4 TO LATER VERSIONS                +
135 +-----------------------------------------------------------------------+
136
137 AMD REMOVED
138 -----------
139
140 The am-utils automounter suite has been removed. It stopped working
141 at some point and was never fixed. autofs(5) and the associated
142 userland has been brought in from FreeBSD and replaces it.
143
144 AN DRIVER REMOVED
145 -----------------
146
147 The an(4) driver has been removed. It was in the X86_64_GENERIC kernel
148 config file, so any configurations derived from it have to be adjusted.
149
150 /DEV/DRI GROUP CHANGED
151 ----------------------
152
153 The default group assigned to /dev/dri entries has been changed
154 from 'wheel' to 'video' with the id of '44'. If you want to have
155 access to the dri devices please add yourself to the video group
156 with:
157
158 # pw groupmod video -m $USER
159
160 +-----------------------------------------------------------------------+
161 +         UPGRADING DRAGONFLY FROM 4.2 TO LATER VERSIONS                +
162 +-----------------------------------------------------------------------+
163
164 DSCHED REMOVED
165 --------------
166
167 dsched(4) has been removed and one of its kernel options, DSCHED_FQ, was
168 in our default kernel config file. So the DSCHED_FQ option has been turned
169 into a no-op for now and can be removed from custom configurations.
170
171 EST DRIVER REMOVED, COMPILE_ET AND LIBCOM_ERR TOO
172 -------------------------------------------------
173
174 The est(4) driver has been removed. All CPUs it supported (except one)
175 were 32 bits only. Those who are still using the Core 2 Duo T7500 should
176 report back if there are any issues with this CPU and our regular ACPI
177 P-state support.
178
179 Also, compile_et(1) and com_err(3) have been removed as well. They
180 should have been removed along with kerberos support, back in 2009.
181
182 SEVERAL LOCALES RENAMED
183 -----------------------
184
185 Several locales were using obsolete and misleading names, and thus have
186 been adjusted to current standards. Any users of the following locales
187 need to select alternates:
188
189 DFLY 4.2 locale            DFLY 4.4 alterative locale
190 ---------------            ------------------------------------
191 mn_MN.UTF-8                mn_Cyrl_MN.UTF-8
192 no_NO.UTF-8                nb_NO.UTF-8      or nn_NO.UTF-8
193 no_NO.ISO8859-1            nb_NO.ISO8869-1  or nn_NO.ISO8859-1
194 no_NO.ISO8859-15           nb_NO.ISO8859-15 or nn_NO.ISO8859-15
195 sr_YU.UTF-8                sr_Cyrl_RS.UTF-8 or sr_Latn_RS.UTF-8
196 sr_YU.ISO8859-5            sr_Cyrl_RS.ISO8859-5
197 sr_YU.ISO8859-2            sr_Latn_RS.ISO8859-2
198 zh_CN.GBK                  zh_Hans_CN.GBK
199 zh_CN.UTF-8                zh_Hans_CN.UTF-8
200 zh_CN.eucCN                zh_Hans_CN.eucCN
201 zh_CN.GB2312               zh_Hans_CH.GB2312
202 zh_CN.GB18030              zh_Hans_CH.GB18030
203 zh_HK.Big5HKSCS            zh_Hant_HK.Big5HKSCS
204 zh_HK.UTF_8                zh_Hant_HK.UTF-8
205 zh_TW.Big5                 zh_Hant_TW.Big5
206 zh_TW.UTF-8                zh_Hant_TW.UTF-8
207
208 +-----------------------------------------------------------------------+
209 +         UPGRADING DRAGONFLY FROM 4.0 TO LATER VERSIONS                +
210 +-----------------------------------------------------------------------+
211
212 BINUTILS 2.25 REPLACES 2.22, PRIMARY
213 ------------------------------------
214
215 The oldest of the two versions of Binutils, version 2.22, was removed
216 and replaced with Binutils 2.25.  It becomes the primary version version
217 of binutils and version 2.24 becomes the alternate.  There are 8 current
218 CVE written against 2.24, so for security reasons version 2.25 should
219 always be used.
220
221 The accepted values of BINUTILSVER are now "binutils225" (default) and
222 "binutils224".  The building of Binutils 2.24 can be prevented by setting
223 NO_ALTBINUTILS=yes in make.conf.
224
225 LOADER OPTIONS CHANGED
226 ----------------------
227
228 Right after the development branch started, the Fred art accompanying the
229 loader menu was improved.  The line between Fred and the menu was removed
230 by default (but can optionally be returned) and the placement shifted as
231 a result.  The drawing was improved, and the colored version was improved,
232 changing the eyes and wing color from white to red.  A new color version
233 of Fred was added, one with a blue scheme.
234
235 The loader menu defaults have changed since release 4.0:  The vertical
236 line was removed, the loader is displayed in color by default*, and the
237 blue scheme is used.
238
239 The loader.conf changes are:
240 loader_color:   option has been removed
241 loader_plain:   option has been added, it changed menu to monochrome
242 fred_is_red:    changes color scheme from blue to red
243 fred_is_blue:   option existed only on 4.1, it has been removed
244 fred_separated: Adds line between Fred and menu (as seen previously)
245
246 * If loader.conf defines "console" as "comconsole" or "console" is defined
247   in the environment as "comconsole" then color will not be displayed,
248   even if loader_plain value is "NO".
249
250 SENDMAIL REMOVED FROM BASE
251 --------------------------
252
253 The only Mail Transfer Agent provided now is DragonFly Mail Agent (dma).
254 If the system being upgraded is still configured to use the sendmail
255 binaries from base, the "make upgrade" command will fail.
256
257 The administrator must change /etc/mail/mailer.conf to switch the
258 mailwrapper to dma or a DPorts-based MTA prior to running the upgrade
259 command that permanently removes sendmail executables and could
260 potentially break a running mail server.
261
262 Refer: http://www.dragonflybsd.com/docs/docs/newhandbook/mta/ for
263 detailed instructions on how to configure the MTA selection.
264
265 _KPOSIX_VERSION and P1003_1B OPTIONS REMOVED
266 --------------------------------------------
267
268 The _KPOSIX_VERSION and P1003_1B kernel options have been changed to
269 no-ops. They can be removed from custom kernel configurations.
270
271 SOUND SYSTEM UPDATED FROM FreeBSD 11-CURRENT
272 --------------------------------------------
273
274 Many more sound devices may be detected.
275
276 If the default device choosen isn't to your liking, setting the sysctl
277 hw.snd.default_unit to a different number will change it.
278
279 SCTP SUPPORT DROPPED
280 --------------------
281
282 Support for the SCTP protocol has been removed.
283
284 OLD USB DRIVERS REMOVED
285 -----------------------
286
287 The old USB stack, along with the kernel config option "device oldusb"
288 and the make.conf variable "WANT_OLDUSB" have been removed. This means
289 that for custom kernel configuration files which were derived from a
290 GENERIC or X86_64_GENERIC file prior to making the usb4bsd stack default,
291 various (old USB stack specific) devices will now complain about being
292 unknown:
293
294   * oldusb      (obviously)
295   * natausb     (not yet ported to usb4bsd)
296   * rue         (not yet ported to usb4bsd)
297   * ugen        (no longer needed in usb4bsd)
298   * urio        (not yet ported to usb4bsd)
299   * uscanner    (no longer needed in usb4bsd)
300
301 They should be removed or commented out in such custom kernel configs.
302
303 GCC 5
304 -----
305
306 The GCC 4.4 compiler has been retired.  It has been replaced by a GCC 5.1.
307 The following make.conf variables no longer work: NO_GCC44, NO_OBJC, and
308 NO_CXX.  The latter was never documented and the latest versions of GCC are
309 partially written in C++ so a C++ compiler is no longer optional.  In
310 practical terms it has not been optional for many years as other base
311 components are also written in C++.  The resource savings by avoiding
312 building Objective-C compiler is so small, the complexity added by NO_OBJC
313 internally was deemed a bad tradeoff so that is the reason for its removal.
314 Also note that no "info" pages are installed with GCC 5.  After this entry
315 was originally written, all info pages were removed from DragonFly.
316
317 GCC 5.1 has been designated as the primary compiler.  As such, there is a
318 new make.conf variable, NO_ALTCOMPILER.  It will block the rebuilding of
319 the designated secondary compiler, GCC 4.7.  However, while DPorts
320 primarily uses GCC 5 to build ports now, it still uses GCC 4.7 as well, so
321 if building ports from source is desired, don't block building of the
322 secondary compiler.
323
324 +-----------------------------------------------------------------------+
325 +         UPGRADING DRAGONFLY FROM 3.8 TO LATER VERSIONS                +
326 +-----------------------------------------------------------------------+
327
328 SMP AND DEVICE_POLLING OPTIONS MADE UNKNOWN
329 -------------------------------------------
330
331 DEVICE_POLLING was replaced by IFPOLL_ENABLE and the former SMP code is
332 the default now (even on single-core systems), both for, like, 21 months.
333 We kept the options around as no-ops as a convenience, to allow people
334 using the same config for the then current release and the then current
335 master. That period is now over, so any configs still having those
336 options have to be adjusted.
337
338 SYSVIPC SYSCALLS MADE NON-OPTIONAL
339 ----------------------------------
340
341 The code related to the SYSVMSG, SYSVSEM and SYSVSHM kernel options is
342 now compiled in by default. The options are no-ops for now.
343
344 DEFAULT DRIVER CHANGED FOR LSI "THUNDERBOLT" SERIES RAID CONTROLLERS
345 --------------------------------------------------------------------
346
347 The default driver for those controllers is now mrsas(4) due to reports
348 of file system corruption using the mfi(4) driver. The whole issue (and
349 how to deal with potential problems when switching) was explained here:
350
351 http://lists.dragonflybsd.org/pipermail/users/2014-July/128703.html
352
353 A tunable is provided for letting those controllers still attach via
354 the mfi(4) driver, hw.mrsas.mfi_enable (see mrsas(4) manual page).
355
356 OLDER NETWORK DRIVERS MOVED TO I386 ONLY
357 ----------------------------------------
358
359 The following drivers have been made i386 only: ed(4), sr(4), ng_sync_ar
360 and ng_sync_sr. ed(4) used to be in X86_64_GENERIC, so it has to be
361 removed in kernel configs derived from X86_64_GENERIC.
362
363 +-----------------------------------------------------------------------+
364 +         UPGRADING DRAGONFLY FROM 3.6 TO LATER VERSIONS                +
365 +-----------------------------------------------------------------------+
366
367 UPDATE FROM MOST RECENT 3.6
368 ---------------------------
369
370 Versions of 3.6 built before June 25th have a bug where installworld might 
371 crash during installation of the new initrd.  Upgrade to the latest version
372 of 3.6 before updating to 3.8 or later.
373
374 ATM, IPX, NCP AND NWFS SUPPORT DROPPED
375 --------------------------------------
376
377 Support for the IPX and NCP network protocols and for mouting NetWare
378 file systems has been dropped. Dito for ATM protocol support.
379
380 INITRD IMAGES NOW INSTALLED BY DEFAULT
381 --------------------------------------
382
383 An initial ramdisk image is now installed in /boot/kernel/initrd.img.gz
384
385 Older images installed under the file name of initrd.img will be removed
386 automatically by the make upgrade process.
387
388 USB4BSD IS NOW THE DEFAULT USB STACK
389 ------------------------------------
390
391 To get back to the old stack, put "WANT_OLDUSB=yes" in /etc/make.conf and
392 replace "device usb" with "device oldusb" in the kernel configuration.
393
394 MORE ISA SUPPORT DROPPED
395 ------------------------
396
397 ISA support has been dropped from the following drivers: adv(4), an(4),
398 ar(4), cs(4), digi(4), ed(4), ep(4), ex(4), fe(4), lnc(4), sbni(4),
399 si(4), sn(4), and stg(4).
400
401 +-----------------------------------------------------------------------+
402 +         UPGRADING DRAGONFLY FROM 3.4 TO LATER VERSIONS                +
403 +-----------------------------------------------------------------------+
404
405 ABI CHANGE
406 ----------
407
408 Installed third-party software (dports) will have to be rebuilt after upgrade,
409 or reinstalled from binary packages.
410
411 UPDATING FROM 3.4 TO 3.6
412 ------------------------
413
414 This only applies for this specific upgrade due to locale changes; it is 
415 not needed for upgrades after 3.6.  Please update in this order:
416
417 make buildworld
418 make buildkernel
419 make installworld
420 make installkernel
421 *reboot*
422 make upgrade
423
424 See this mailing list post for details:
425 http://lists.dragonflybsd.org/pipermail/users/2013-September/090163.html
426
427 CYRIX OPTIONS REMOVED
428 ---------------------
429
430 The following Cyrix related options have been removed: CPU_BTB_EN,
431 CPU_CYRIX_NO_LOCK, CPU_DIRECT_MAPPED_CACHE, CPU_DISABLE_5X86_LSSER,
432 CPU_FASTER_5X86_FPU, CPU_IORT, CPU_LOOP_EN, CPU_RSTK_EN, CPU_SUSP_HLT,
433 CYRIX_CACHE_WORKS, and CYRIX_CACHE_REALLY_WORKS
434
435 ISA SUPPORT REMOVED FROM RP(4)
436 ------------------------------
437
438 ISA support has been removed from the rp(4) driver. It is now PCI only.
439
440 +-----------------------------------------------------------------------+
441 +         UPGRADING DRAGONFLY FROM 3.2 TO LATER VERSIONS                +
442 +-----------------------------------------------------------------------+
443
444 COMPAT_SUNOS OPTION REMOVED
445 ---------------------------
446
447 The COMPAT_SUNOS option has been removed. It was meant to provide binary
448 compatibility with SunOS 4.x for the sparc32 port of 4.4BSD.
449
450 ISA SOUND CARD SUPPORT REMOVED
451 ------------------------------
452
453 The following modules have been removed (all for ISA sound cards):
454 snd_ad1816.ko, snd_ess.ko, snd_mss.ko, snd_sb8.ko, snd_sb16.ko, snd_sbc.ko
455
456 GCC 4.7
457 -------
458
459 DragonFly has switched base compilers.  GCC 4.7 is now the default
460 compiler and GCC 4.4 is the alternative compiler.  The "NO_GCC47" make
461 variable ceases to work now.
462
463 Users who wish to build only GCC 4.7 have to use NO_GCC44 in the
464 /etc/make.conf to prohibit GCC 4.4 from building.  However, using it is
465 highly discouraged.  There are a few packages in pkgsrc that do not build
466 with GCC 4.7 and the new "DPorts" system uses GCC 4.4 by default.  At
467 this time, it is recommended to keep both compilers on the base system.
468
469 SMP OPTION REMOVED
470 ------------------
471
472 The SMP kernel option has been made a no-op. All kernels now feature SMP
473 support. If you have 'options SMP' in your kernel config, you can as well
474 remove it.
475
476 DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
477 ---------------------------------------------------------------------------
478
479 The DEVICE_POLLING kernel option has been made a no-op and it has been
480 replaced by IFPOLL_ENABLE.  If you have 'options DEVICE_POLLING' in your
481 kernel config, you need to change it to IFPOLL_ENABLE.
482
483 Also, the KTR_POLLING kernel option has been removed, so it must be
484 removed from kernel configs that have it.
485
486 BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
487 ---------------------------------------------------
488
489 The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
490 cards will no longer be detected.
491
492 The same has been done for Stallion multiport serial controllers. stli(4)
493 has been completely removed (along with the stlload(8) and stlstty(8)
494 utilities) and stl(4) was changed to support only PCI cards. Similarly,
495 ISA support was removed from cy(4) too. All these drivers are i386 only.
496
497 COMPAT_OLDISA OPTION GONE
498 -------------------------
499
500 The i386 specific COMPAT_OLDISA kernel option has been removed, since
501 nothing needs it anymore.
502
503 +-----------------------------------------------------------------------+
504 +         UPGRADING DRAGONFLY FROM 3.0 TO LATER VERSIONS                +
505 +-----------------------------------------------------------------------+
506
507 APIC_IO OPTION REMOVED
508 ----------------------
509
510 The APIC_IO kernel option is no longer accepted after having been without
511 effect for a while. The hw.ioapic_enable tunable now serves its purpose.
512 If you have 'options APIC_IO' in your kernel config, you'll have to
513 remove it.
514
515 WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
516 -----------------------------------------
517
518 The wdog framework is now compiled into our kernels by default, so the
519 options are no longer needed.
520
521 DOSCMD(1) REMOVED
522 -----------------
523
524 doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
525 NO_X make.conf option was removed too.
526
527 GCC 4.7
528 -------
529
530 GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
531 default compiler in base (default is still GCC 4.4).
532
533 Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
534 NO_GCC47 in /etc/make.conf.
535
536 USB4BSD
537 -------
538
539 A new USB stack (from FreeBSD) has been brought in. The following
540 modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
541 usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
542 and uaudio.
543
544 It is not yet the default. To activate it, WANT_USB4BSD=yes has to
545 be put in make.conf and device "usb4bsd" (quotes needed) has to
546 replace device usb in the kernel config. After that, a full
547 build/install/upgrade cycle is needed.
548
549 Note that this is experimental and incomplete, but we are interested
550 in hearing about issues with it, of course.
551
552 ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
553 ---------------------------------------------
554
555 ISA adapter support was dropped from the aic(4) driver.
556
557 +-----------------------------------------------------------------------+
558 +         UPGRADING DRAGONFLY FROM 2.10 TO LATER VERSIONS               +
559 +-----------------------------------------------------------------------+
560
561 SEVERAL ISA DRIVERS REMOVED
562 ---------------------------
563
564 The following ISA only drivers have been removed along with a couple of
565 associated userland tools:
566
567 aha(4)
568 asc(4) & sasc(1)
569 ctx
570 dgb(4)
571 el(4)
572 gpib
573 gsc(4) & sgsc(1)
574 ie(4)
575 labpc(4)
576 le(4)
577 mse(4)
578 rc(4)
579 rdp(4)
580 spigot
581 tw(4) & xten(1) & xtend(8)
582 wl(4) & wlconfig(8)
583 wt(4)
584
585 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
586 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
587 file.
588
589 If buildkernel complains about any of these drivers, just remove them
590 from your kernel configuration.
591
592 BINUTILS 2.20
593 -------------
594 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
595 values of BINUTILSVERS are now binutils221 and binutils222 (default).
596
597 BUILDWORLD/-KERNEL PARALLELIZATION WORK
598 ---------------------------------------
599 Due to changes in the way we build with more than one make job, you
600 will have to update install(1) and mkdir(1) prior to buildworld if you
601 want to build with 'make -j':
602
603 cd /usr/src/usr.bin/xinstall; make; make install; make clean
604 cd /usr/src/bin/mkdir; make; make install; make clean
605
606 DMA(8) UPGRADE
607 --------------
608 dma(8) has been upgraded to v0.7 which no longer supports the
609 /etc/dma/virtusertable. Some of its functionality has been replaced
610 with the MASQUERADE keyword and the EMAIL environment variable (see
611 the dma(8) manual page).
612
613 +-----------------------------------------------------------------------+
614 +         UPGRADING DRAGONFLY FROM 2.8 TO LATER VERSIONS                +
615 +-----------------------------------------------------------------------+
616
617 GCC 4.4 & BINUTILS 2.21
618 -----------------------
619
620 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
621 been made DragonFly's default Binutils.
622
623 That means that any settings that set CCVER to 'gcc44' are not needed
624 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
625 GCC 4.1.
626
627 It also means that 'binutils221' as a value for BINUTILSVER has no
628 effect anymore. 2.17 has been removed and 'binutils220' is available
629 as an option.
630
631 The NO_GCC44 option has been removed and will not affect the build
632 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
633 building in a similar fashion.
634
635 Note that you must do a full buildworld/buildkernel for upgrading.
636
637 pkg_radd settings
638 -----------------
639
640 The config file for pkg_radd has moved from /etc/settings.conf to 
641 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
642 if this is needed.  This warning only applies if /etc/settings.conf 
643 exists.  pkg_radd will continue to work with defaults.
644
645 +-----------------------------------------------------------------------+
646 +         20100927                                                      +
647 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
648 +-----------------------------------------------------------------------+
649
650 OpenSSL
651 --------
652
653 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
654 This shouldn't break any 3rd-party software, but you'll need to recompile your
655 3rd-party software if you want it to link against the new version of OpenSSL.
656
657 Loader
658 -------
659
660 A new loader (dloader) has been added which better handles booting from
661 multiple kernel/module versions.
662
663 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
664
665         cd /usr/src
666         make buildworld
667         make installworld
668         make upgrade
669         make buildkernel KERNCONF=<KERNELNAME>
670         make installkernel KERNCONF=<KERNELNAME>
671
672 Note that you must installworld and run the 'upgrade' target before
673 installing the new kernel.
674
675 BIND
676 -----
677
678 BIND has been removed from the base system.  The ldns and drill tools have 
679 been added for basic functionality.  Use 'drill' where you would normally 
680 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
681 net/bind95, net/bind96, or net/bind97 as of this writing.
682
683 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
684 include BIND as a pkgsrc package.
685
686 +-----------------------------------------------------------------------+
687 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
688 +                               GENERAL                                 +
689 +-----------------------------------------------------------------------+
690
691 Instructions on how to obtain and maintain DragonFly source code using git
692 are in the development(7) manual page.
693
694 To upgrade a DragonFly system from sources you run the following sequence:
695
696         cd /usr/src
697         make buildworld
698         make buildkernel KERNCONF=<KERNELNAME>
699         make installkernel KERNCONF=<KERNELNAME>
700         make installworld
701
702 You will also want to run the 'upgrade' target to upgrade your /etc and the
703 rest of your system.  The upgrade target is aware of stale files created by
704 older DragonFly installations and should delete them automatically.
705
706         make upgrade
707
708 See the build(7) manual page for further information.
709
710 Once you've done a full build of the world and kernel you can do incremental
711 upgrades of either by using the 'quickworld' and 'quickkernel' targets
712 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
713 the quick targets, try updating your repo first, and then a full buildworld
714 and buildkernel as shown above, before asking for help.
715
716 +-----------------------------------------------------------------------+
717 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
718 +-----------------------------------------------------------------------+
719
720 In 2.1 kernel and modules has moved to boot directory.  For most cases
721 this is handled automatically by 'make upgrade'.  A few cases needs manual
722 intervention:
723
724  * When installing a kernel without first doing a make buildworld,
725    installworld and upgrade to the same DESTDIR as kernel:
726    make DESTDIR/boot directory and move kernel and modules into this boot
727    directory; also move kernel.old and modules.old.
728    Typical example is vkernel(7), use (no modules used):
729
730         cd /var/vkernel
731         mkdir boot
732         chflags noschg kernel
733         mv kernel kernel.old boot
734         chflags schg boot/kernel
735         
736  * When using a boot-only partition, /boot/loader.rc needs to be edited:
737    delete occurrences of '/boot/'.
738    These occurences can normally be deleted in any case, see loader(8).
739
740 +-----------------------------------------------------------------------+
741 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
742 +-----------------------------------------------------------------------+
743
744 In 1.9 major changes to the disk management infrastructure have taken
745 place.  make upgrade may not catch all of your disk devices in /dev,
746 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
747 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
748 and MAKEDEV no longer exists.
749
750 The biggest changes in 1.9 are:
751
752 (1) That whole-slice devices such as da0s1 no longer share the same device
753     id as partition c devices such as da0s1c.
754
755 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
756     with no snooping or reserved sectors.  Consequently you cannot run
757     disklabel on this device.  Instead you must run disklabel on a
758     whole-slice device.
759
760 (3) The 'compatibility' partitions now use slice 0 in the device name,
761     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
762     accessing the disklabel for the compatibility partitions must be
763     done via slice 0 (da0s0).
764
765 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
766     and CCD now run through the disk management layer and are assigned
767     real disk management devices.   VN and CCD in particular do not usually
768     use a MBR and disklabels must be accessed through the compatibility
769     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
770     don't name it 'ccd0s0' in the config file.
771
772 Generally speaking, you have to get used to running fdisk and disklabel on
773 the correctly specified device names.  A lot of the wiggle, such as running
774 disklabel on a partition, has been removed.
775
776 +-----------------------------------------------------------------------+
777 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
778 +-----------------------------------------------------------------------+
779
780 > Kerberos IV
781 -------------
782
783 Kerberos IV (eBones) was removed from the tree, please consider moving to
784 Kerberos 5 (Heimdal).
785
786 > Package Management System
787 ---------------------------
788
789 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
790 management system.  The necessary tools to build and maintain packages
791 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
792 directories are in your PATH variable.
793
794 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
795 the tarball from NetBSD:
796
797         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
798         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
799
800 This tree can then be kept up to date with cvs update:
801
802         cd /usr/pkgsrc; cvs up
803
804 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
805 build and install the pkgsrc bootstrap manually:
806
807         cd /usr/pkgsrc/bootstrap
808         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
809
810 +-----------------------------------------------------------------------+
811 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
812 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
813 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
814 +-----------------------------------------------------------------------+
815
816 The compatibility shims for the build environment have been removed, you
817 have to update to DragonFly 1.2 release branch first.
818
819 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
820 The existing configuration can be converted using /etc/pam.d/convert.sh.
821 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
822 the pam_skey.so module was retired, you have to remove it manually from
823 your configuration, when you convert it.
824
825 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
826 ---------------------
827
828 The following users may be missing from your password file.  Use vipw and
829 add any that are missing:
830
831 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
832 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
833
834 The following groups may be missing from your group file.  Use vi /etc/group
835 and add any that are missing:
836
837 smmsp:*:25:
838 authpf:*:63:
839 _pflogd:*:64:
840
841
842 > Upgrading to DragonFly from FreeBSD
843 ---------------------
844
845 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
846 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
847 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
848 make depend information, it starts from scratch, so no pre-cleaning of the
849 object hierarchy is necessary.
850
851         # get the CVS repository (it is placed in /home/dcvs, 500MB).
852         # Please use the -h option and a mirror site to pull the 
853         # initial repository, but feel free to use the main repository
854         # machine to pull updates.
855         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
856         # install the source from the CVS hierarchy (remove preexisting
857         # FreeBSD src first) (500MB)
858         cd /usr
859         rm -rf src
860         cvs -R -d /home/dcvs checkout -P src
861
862         # build it (500MB used in /usr/obj)
863         #
864         cd /usr/src
865         make buildworld
866         make buildkernel KERNCONF=<KERNELNAME>
867
868 Once you have built DragonFly you have to install it over FreeBSD.  Since
869 DragonFly does not track changes made by FreeBSD to its include file 
870 hierarchy and include file pollution can cause all sorts of unexpected
871 compilation issues to come up, it is best to wipe your include hierarchy
872 prior to installing DragonFly.  Note that you should not wipe any installed
873 FreeBSD header files or binaries until after you have successfully completed
874 the build steps above.
875
876         rm -rf /usr/include
877         mkdir /usr/include
878         make installkernel KERNCONF=<KERNELNAME>
879         make installworld
880
881 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
882 will unconditionally upgrade the /etc files that sysops do not usually
883 mess around with, such as the files in /etc/rc.d.  It will also remove any
884 obsolete files such as utilities and manpages that have been removed from
885 the system since the version you're coming from.  If you are unsure we 
886 recommend that you make a backup of at least your /etc before applying
887 this step.  Note that DragonFly's RC system is basically RCNG from
888 FreeBSD-5, but there are some differences in the contents of the RC files.
889
890         make upgrade
891
892 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
893 Doing so might leave your system in an unusable state.
894
895 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
896 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
897 report these files to the DragonFly developers so that they can be added to
898 the 'upgrade' target.
899